<template>
	<StackLayout :isEnabled="isEnabled" class="fab-item" :class="[classItem, classBackItem]" :backgroundColor="color" @tap="buttonOptionTap">
		<Label :text="title" horizontalAlignment="center"/>
	</StackLayout>
</template>

<script>
import Foto from '../evidencias/Foto';
import ModalConfirm from './ModalConfirm';
import { urlApi } from '../../main.js';
import axios from 'axios';
import store from '../../store';
	
	export default {
	props: ['title', 'color', 'tipo', 'id', 'tipo_a', 'actividad_id'],
	components:{ Foto },
	data(){
		return{
			isExec: false
		}
	},
	computed: {
		classItem(){
			if(this.tipo==1){
				return this.isActive ? "raiseItem1" : "";//this.isActive == 2 ? "downItem1":"";
			}else if(this.tipo==2){
				return this.isActive ? "raiseItem2" : "";
			}else if(this.tipo==3){
				return this.isActive ? "raiseItem3" : "";
			}else if(this.tipo==4){
				return this.isActive ? "raiseItem4" : "";
			}else if(this.tipo==5){
				return this.isActive ? "raiseItem5" : "";
			}
		},
		classBackItem() {
			if(this.tipo<5){
				return this.isEnabled ? "activedItem" : "desactivatedItem"
			}else{
				return "activedItem";
			}
		},
		isActive(){
			return store.getters.getIsActiveMenuButton(this.id) ? true:false;
		},
		isEnabled(){
			return store.getters.getIsEnabledOptionButton({id:this.id, tipo:this.tipo}) ? true:false;
		},
	},
	methods:{
		buttonOptionTap(){
			console.log('indice: ', this.id, 'tipo: ', this.tipo);
            var status_id = 0;
            if(this.tipo == 5){
				console.log('take photo');
				store.dispatch('setPage', 0);
                this.$navigateTo(Foto, { props: { id: this.id } });
            }else if (this.tipo == 4) {
				status_id = 2;
				if(this.tipo_a == 1){
					this.$showModal(ModalConfirm, {
					    props: {actividad_id: this.actividad_id}
					})
					.then(data => {
						if(data)
							this.changeStatus(status_id);
					});
				}else{this.changeStatus(status_id);}
                console.log('4');
            }else if(this.tipo == 3){
				status_id = 3;
				this.changeStatus(status_id);
                console.log('3');
            }else if(this.tipo == 2){
				status_id = 4;
				this.changeStatus(status_id);
                console.log('2');
            }else{
				status_id = 5;
				this.changeStatus(status_id);
                console.log('1');
            }
		},
		changeStatus(status_id){
			axios.post(urlApi+`/api/v1/mtto/actividad/${this.id}/cambio-estatus`,{
				maintenance_log_id: this.id,
				status_id: status_id,
			})
			.then(respuesta=>{	
				store.dispatch('setIsActiveMenuButton', this.id);
				this.$emit('listado');
			})
			.catch(error=>{
				console.log(error);
			});
		}
	},
}

</script>

<style scoped>
	.fab-item {
		width: 40;
		height: 40;
		border-radius: 20;
		color: #fff;
		font-weight: bold;
		vertical-align: center;
	}

	.fab-item-cam {
		width: 45;
		height: 45;
		border-radius: 25;
		color: #fff;
		font-weight: bold;
		vertical-align: center;
	}

	.raiseItem1 {
		opacity: 1;
		animation-name: raiseItem1;
		animation-duration: .25;
		animation-timing-function: cubic-bezier(0.165, 0.840, 0.440, 1.000);
		animation-fill-mode: forwards;
	}

	.raiseItem2 {
		opacity: 1;
		animation-name: raiseItem2;
		animation-duration: .25;
		animation-timing-function: cubic-bezier(0.165, 0.840, 0.440, 1.000);
		animation-fill-mode: forwards;
	}

	.raiseItem3 {
		opacity: 1;
		animation-name: raiseItem3;
		animation-duration: .25;
		animation-timing-function: cubic-bezier(0.165, 0.840, 0.440, 1.000);
		animation-fill-mode: forwards;
	}

	.raiseItem4 {
		opacity: 1;
		animation-name: raiseItem4;
		animation-duration: .25;
		animation-timing-function: cubic-bezier(0.165, 0.840, 0.440, 1.000);
		animation-fill-mode: forwards;
	}

	.raiseItem5 {
		opacity: 1;
		animation-name: raiseItem5;
		animation-duration: .25;
		animation-timing-function: cubic-bezier(0.165, 0.840, 0.440, 1.000);
		animation-fill-mode: forwards;
	}

	.downItem1 {
		animation-name: raiseItem1;
		animation-duration: .20;
		animation-timing-function: cubic-bezier(0.895, 0.030, 0.685, 0.220);
		animation-fill-mode: forwards;
		animation-direction: reverse;
	}

	.downItem2 {
		animation-name: raiseItem2;
		animation-duration: .20;
		animation-timing-function: cubic-bezier(0.895, 0.030, 0.685, 0.220);
		animation-fill-mode: forwards;
		animation-direction: reverse;
	}

	.downItem3 {
		animation-name: raiseItem3;
		animation-duration: .20;
		animation-timing-function: cubic-bezier(0.895, 0.030, 0.685, 0.220);
		animation-fill-mode: forwards;
		animation-direction: reverse;
	}

	.downItem4 {
		animation-name: raiseItem4;
		animation-duration: .20;
		animation-timing-function: cubic-bezier(0.895, 0.030, 0.685, 0.220);
		animation-fill-mode: forwards;
		animation-direction: reverse;
	}

	.downItem5 {
		animation-name: raiseItem5;
		animation-duration: .20;
		animation-timing-function: cubic-bezier(0.895, 0.030, 0.685, 0.220);
		animation-fill-mode: forwards;
		animation-direction: reverse;
	}

	.activedItem{    
		animation-name: pulse;
		animation-duration: 1;
		animation-fill-mode: forwards;
	}

	.desactivatedItem{
		animation-name: pulse;
		animation-duration: 1;
		animation-direction: reverse;
		animation-fill-mode: forwards;
	}

	@keyframes activateBackdrop {
		from {
			opacity: 0;
		}
		to {
			opacity: 1;
		}
	}

	@keyframes raiseItem1 {
		from {
			opacity: 1;
			transform: translate(0, 0);
		}
		to {
			opacity: 1;
			transform: translateX(-60);
		}
	}

	@keyframes raiseItem2 {
		from {
			opacity: 1;
			transform: translate(0, 0);
		}
		to {
			opacity: 1;
			transform: translateX(-120);
		}
	}

	@keyframes raiseItem3 {
		from {
			opacity: 1;
			transform: translate(0, 0);
		}
		to {
			opacity: 1;
			transform: translateX(-60);
		}
	} 

	@keyframes raiseItem4 {
		from {
			opacity: 1;
			transform: translate(0, 0);
		}
		to {
			opacity: 1;
			transform: translateX(-120);
		}
	} 

	@keyframes raiseItem5 {
		from {
			opacity: 1;
			transform: translate(0, 0);
		}
		to {
			opacity: 1;
			transform: translateX(-180);
		}
	} 

	@keyframes pulse {
        from {
			opacity: 0.5;
		}
		to {
			opacity: 1;
		}
	}
</style>